#!/usr/bin/env python
import sys
import math 

with open("local.txt", "r") as local_file:
    localValues=local_file.readlines()
with open("remote.txt", "r") as remote_file:
    remoteValues=remote_file.readlines()
    

nameTable=sys.argv[1]
nameField=sys.argv[2]

print "CREATE TABLE %s (ID  mediumint(8) AUTO_INCREMENT, NAME_CIG varchar(32), %s decimal(6,3), ERROR decimal(6,3), DIF_VAL decimal(6,3), DIF_ERR decimal(6,3), ADDED BOOL, REMOVED BOOL, PRIMARY KEY (ID) );\n"%(nameTable, nameField)

num_values=min(len(localValues), len(remoteValues))
        
for i in range(num_values):
    try:
        (lname, lvalue, lerr)=localValues[i].split()
        (rname, rvalue, rerr)=remoteValues[i].split()
        lvalue=float(lvalue)
        lerr=float(lerr)
        rvalue=float(rvalue)
        rerr=float(rerr)        
 	        
        added=0
        removed=0
        
        if math.isnan(lvalue) and not math.isnan(rvalue):
        	added=1
        if not math.isnan(lvalue) and math.isnan(rvalue):
        	removed=1                     	
        
    except:
        print "/*No update for galaxy %s*/\n"%(i+1)
    else:
        value_diff=lvalue-rvalue
        err_diff=lerr-rerr
        
        if math.isnan(value_diff):
        	value_diff="NULL"
        if math.isnan(err_diff):
        	err_diff="NULL"

        if math.isnan(rvalue):
        	rvalue="NULL"
        if math.isnan(rerr):
        	rerr="NULL"    
        	
        print "INSERT INTO %s (NAME_CIG, %s, ERROR, DIF_VAL, DIF_ERR, ADDED, REMOVED) VALUES ('%s', %s, %s, %s, %s, %s, %s);"%(nameTable, nameField, rname, rvalue, rerr, value_diff, err_diff, added, removed)