import sys
from math import *

#Calculating ai = f (t, log r25) = -2.5log[k+(1-k)R*((2C(1+0.2/K2)-1)]

with open ("type.txt", "r") as type_file:
    types=type_file.readlines()

with open ("logr25.txt", "r") as logr25_file:
    logr25s=logr25_file.readlines()

with open ("velocity.txt", "r") as velocity_file:
    velocities=velocity_file.readlines()

with open ("bt.txt", "r") as bt_file:
    bts=bt_file.readlines()
    
with open ("ag.txt", "r") as ag_file:
    ags=ag_file.readlines()    


C=float(sys.argv[1])

#Building a dictionary with the ak values
ak={-5:float(sys.argv[2]), \
        -4:float(sys.argv[2]),\
        -3:float(sys.argv[2]),\
        -2:float(sys.argv[2]),\
        -1:float(sys.argv[2]),\
        0:float(sys.argv[2]),
        1:float(sys.argv[3]), \
        2:float(sys.argv[4]), \
        3:float(sys.argv[5]), \
        4:float(sys.argv[6]), \
        5:float(sys.argv[7]), \
        6:float(sys.argv[8]), \
        7:float(sys.argv[9]), \
        8:float(sys.argv[10]), \
        9:float(sys.argv[11]), \
        10:float(sys.argv[12]), \
        }

max=min(len(types), len(logr25s), len(velocities), len(bts), len(ags))

for i in range(max):
    
    try:
        (name, type, errtype)=types[i].split()
        (name, logr25, errlog)=logr25s[i].split()
        (name, velhel, errvel)=velocities[i].split()
        (name, bt, errbt)=bts[i].split()
        (name, ag, errag)=ags[i].split()
        type=float(type)
        logr25=float(logr25)
        bt=float(bt)
        velhel=float(velhel)
        ag=float(ag)
        
    except:
        print "Format error in galaxy %i"%i
        print types[i]
        print logr25s[i]
        print velocities[i]
        print bts[i]
        print ags[i]
    else:

        #CALCULATING ai
        #Calculating k
        k=0.754*pow(10, (-0.2*type))
        if k>1:
            k=1
    
        #Calculating K2
        if type<0:
            K2 = 0.12-0.007*type
        else:
            K2=0.094
        #Calculating R
        R = 10.**logr25
        
        #Finally it calculates ai
        #ai=-2.5*log(k+(1.0-k)*R*((2.0*C*(1+0.2/K2)-1)))
        tmp=2.0*C*(1+0.2/K2)-1
        
        ai=-2.5*log10(k+(1.0-k)*pow(R, tmp))
       
        #Calculating ak
        if isnan(type):
        	aki=float("nan")
        else:	
        	aki=ak[int(round(type))] 
        	#aki=0.0401445
       
        btc = bt - ag - ai - aki*velhel/10000
    	if isnan(btc):
    		btc="NaN"
    	
        print name,  btc, "NaN"
    